SystemOrganization addCategory: #MemoryMentor!
SystemOrganization addCategory: #'MemoryMentor-Tests'!

!ByteArray methodsFor: '*MemoryMentor' stamp: 'RL 5/3/2013 11:38:58.14'!
intAt: index
	| word |
	<primitive: 165>
	word := self basicAt: index.
	word < 16r3FFFFFFF ifTrue:[^word]. "Avoid LargeInteger computations"
	^word >= 16r80000000	"Negative?!!"
		ifTrue:["word - 16r100000000"
				(word bitInvert32 + 1) negated]
		ifFalse:[word]! !

!ByteArray methodsFor: '*MemoryMentor' stamp: 'RL 5/3/2013 11:44:13.346'!
intAt: index put: anInteger
	| word |
	<primitive: 166>
	anInteger < 0
		ifTrue:[anInteger < -16r80000000 ifTrue: [self error: anInteger asString , ' out of range'].
				"word := 16r100000000 + anInteger"
				word := (anInteger + 1) negated bitInvert32]
		ifFalse:[anInteger > 16r7FFFFFFF ifTrue: [self error: anInteger asString , ' out of range'].
				word := anInteger].
	self  basicAt: index put: word.
	^anInteger! !

Morph subclass: #MMMemoryCellMorph
	instanceVariableNames: 'cell displayMode cellMorphs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor'!

!MMMemoryCellMorph class methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 13:43:55.154'!
for: cell
	^ self new
		setupCell: cell;
		yourself! !

!MMMemoryCellMorph methodsFor: 'as yet unclassified' stamp: 'WS 5/8/2013 13:42:11.592'!
contentStringForByte: anInteger
	| cellData |
	cellData := cell byteAt: anInteger.
	^ displayMode caseOf: {
		[ #decimal ] -> [
			cellData printString
		].
		[ #binary ] -> [
			((cellData printStringBase: 2) padded: #left to: 8 with: $0), 'b'
		].
		[ #hexadecimal ] -> [
			'0x', (cellData printStringBase: 16) padded: #left to: 2 with: $0
		].
		[ #ascii ] ->[
			cellData >= 32
				ifTrue:[ (Character value: cellData) asString printString ]
				ifFalse: [ ('\', cellData asString) printString ]
		].
	}! !

!MMMemoryCellMorph methodsFor: 'as yet unclassified' stamp: 'WS 5/8/2013 11:58:26.608'!
createByte: i
	|morph width height|
	width := (TextStyle default defaultFont widthOf: $0) * (8+4).
	height := TextStyle default defaultFont height + 5.
	morph := BorderedMorph new
		extent: width @ height;
		color: (Color gray: 0.9);
		layoutPolicy: TableLayout new;
		listDirection: #leftToRight;
		listCentering: #center;
		yourself.
	morph addMorph: (StringMorph new
		contents: (self contentStringForByte: i);
		yourself).
	^ morph! !

!MMMemoryCellMorph methodsFor: 'as yet unclassified' stamp: 'WS 5/8/2013 13:31:15.516'!
displayMode: aSymbol
	(#(ascii binary decimal hexadecimal) includes: aSymbol) ifFalse:
		[ self error: 'DisplayMode ', aSymbol asString, ' not supported'].
	
	displayMode := aSymbol.
	
	self displayModeChanged! !

!MMMemoryCellMorph methodsFor: 'as yet unclassified' stamp: 'WS 5/8/2013 13:38:13.822'!
displayModeChanged
	0 to: 3 do: [ :i |
		(cellMorphs at: i+1) ifNotNil: [ :morph |
			morph submorphs first contents: (self contentStringForByte: i)
		]
	]! !

!MMMemoryCellMorph methodsFor: 'as yet unclassified' stamp: 'WS 5/8/2013 13:32:04.408'!
initialize 
	super initialize.
	cellMorphs := Array new: 4.
	self color: Color white.
	self displayMode: #ascii.
	self
		layoutPolicy: TableLayout new;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		listDirection: #leftToRight;
		listCentering: #left! !

!MMMemoryCellMorph methodsFor: 'as yet unclassified' stamp: 'WS 5/8/2013 13:27:39.014'!
openMenu
	| menu formatMenu |
	formatMenu := MenuMorph new
		add: 'Binary' target: self selector: #displayMode: argument: #binary;
		add: 'Decimal' target: self selector: #displayMode: argument: #decimal;
		add: 'Hexadecimal' target: self selector: #displayMode: argument: #hexadecimal;
		add: 'ASCII' target: self selector: #displayMode: argument: #ascii;
		yourself.
	
	menu := MenuMorph new.
	menu add: 'Format' subMenu: formatMenu.
	
	menu popUpInWorld.! !

!MMMemoryCellMorph methodsFor: 'as yet unclassified' stamp: 'WS 5/8/2013 13:40:26.466'!
openMenuButton
	| button |
	button := UiPushButton new.
	button text: ' '.
	self connect: button signal: #clicked: toSelector: #openMenu.
	^ button
		! !

!MMMemoryCellMorph methodsFor: 'as yet unclassified' stamp: 'WS 5/8/2013 13:33:15.176'!
setupCell: aCell
	|labelMorph width height|
	cell := aCell.
	width := (TextStyle default defaultFont widthOf: $0) * 
			(('0x', (cell memory endAddress printStringBase: 16)) size + 1).
	height := TextStyle default defaultFont height + 5.
	labelMorph := Morph new
		color: Color white;
		extent: width@height;
		layoutPolicy: TableLayout new;
		listDirection: #topToBottom;
		listCentering: #center;
		yourself.
	labelMorph addMorph: 
		(StringMorph new 
			contents: '0x', (cell address printStringBase: 16); 
			yourself).
	self addMorphBack: labelMorph. 
	1 to: 4 do: [ :i | | cellMorph |
		cellMorph := self createByte:i-1.
		cellMorphs at: i put: cellMorph.
		self addMorphBack: cellMorph.
	].
	self addMorphBack: self openMenuButton.
	self extent: self fullBounds extent.! !

Morph subclass: #MMMemoryMorph
	instanceVariableNames: 'memory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor'!

!MMMemoryMorph class methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 13:14:59.09'!
for: memory
	^ self new
		setupMemory: memory;
		yourself! !

!MMMemoryMorph methodsFor: 'as yet unclassified' stamp: 'WS 5/8/2013 11:55:36.804'!
initialize
	super initialize.
	
	self
		layoutPolicy: TableLayout new;
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		listDirection: #topToBottom;
		listCentering: #center
! !

!MMMemoryMorph methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 13:02:34.86'!
memory: aMemory
	memory := aMemory! !

!MMMemoryMorph methodsFor: 'as yet unclassified' stamp: 'WS 5/8/2013 11:18:45.236'!
setupMemory: aMemory
	memory := aMemory.
	memory cellsDo: [ :cell |
		self addMorphBack: (MMMemoryCellMorph  for: cell).
	].
	self extent: self fullBounds extent.! !

Object subclass: #MMMemory
	instanceVariableNames: 'startAddress memory cells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor'!

!MMMemory class methodsFor: 'as yet unclassified' stamp: 'lt 5/8/2013 11:25:14.594'!
withStartAddress: startAddress bytes: aByteArray

	^ self 
		withStartAddress: startAddress 
		bytes: aByteArray 
		cellCount: (aByteArray size / 4) ceiling! !

!MMMemory class methodsFor: 'as yet unclassified' stamp: 'lt 5/8/2013 11:25:30.614'!
withStartAddress: startAddress bytes: aByteArray cellCount: aNumber
	|instance|
	instance := self withStartAddress: startAddress cellCount: aNumber.
	instance at: startAddress putByteArray: aByteArray.
	^ instance! !

!MMMemory class methodsFor: 'as yet unclassified' stamp: 'lt 5/8/2013 11:17:01.288'!
withStartAddress: startAddress cellCount: aNumber
	^ self new
		initializeWithStartAddress: startAddress cellCount: aNumber;
		yourself! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 15:31:02.124'!
at: address putByte: byte
	memory byteAt: (self indexForAddress: address) put: byte! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'WS 5/8/2013 11:27:13.602'!
at: address putByteArray: byteArray
	(byteArray size > (cells size * 4) ifTrue: [ byteArray first: cells size * 4 ] ifFalse: [ byteArray ])
		withIndexDo: [ :byte :index |
		self at: address+index-1 putByte: (byteArray at: index)
	]! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 15:32:11.56'!
at: address putInt: int
	memory intAt: (self indexForAddress: address) put: int! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 15:25:05.046'!
byteAt: adress
	 ^ memory at: (self indexForAddress: adress)! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'WS 5/3/2013 13:04:27.336'!
byteSize
	^ memory size! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 14:14:26.12'!
cellAtAddress: address
	^ cells at: (self cellIndexForAddress: address)! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'lt 5/8/2013 11:53:43.905'!
cellCount
	^ cells size! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 14:13:45.782'!
cellIndexForAddress: address
	^ ((address roundDownTo: 4) - startAddress)/4 + 1! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 13:24:07.742'!
cellsDo: aBlock
	^ cells do: aBlock! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'lt 5/8/2013 11:54:00.067'!
endAddress
	^ startAddress + (self cellCount * MMMemoryCell size)! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 14:12:46.656'!
indexForAddress: address
	^ address - startAddress + 1! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'lt 5/8/2013 11:16:31.907'!
initializeWithStartAddress: adress cellCount: aNumber
	startAddress := adress.
	memory := ByteArray new: aNumber*4.
	cells := OrderedCollection new.
	1 to: aNumber do: [ :i |
		cells add: (MMMemoryCell at: (4*(i-1) + startAddress) in: self)
	]! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 15:32:31.124'!
intAt: address
	 ^ memory intAt: (self indexForAddress: address)! !

!MMMemory methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 14:12:09.978'!
startAddress
	^ startAddress! !

Object subclass: #MMMemoryCell
	instanceVariableNames: 'address memory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor'!

!MMMemoryCell class methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 14:15:46.536'!
at: address in: memory
	 ^ self new
		initializeWithAddress: address andMemory: memory;
		yourself! !

!MMMemoryCell class methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 12:41:51.122'!
size
	 ^ 4! !

!MMMemoryCell methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 14:15:11.996'!
address
	^ address! !

!MMMemoryCell methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 15:22:27.266'!
byteAt: index
	^ memory byteAt: address + index! !

!MMMemoryCell methodsFor: 'as yet unclassified' stamp: 'RL 5/3/2013 14:15:28.346'!
initializeWithAddress: anAddress andMemory: aMemory
	address := anAddress.
	memory := aMemory! !

!MMMemoryCell methodsFor: 'as yet unclassified' stamp: 'lt 5/8/2013 11:53:00.459'!
memory
	^ memory! !

TestCase subclass: #MMMemoryCellTest
	instanceVariableNames: 'memory startAddress size cell address'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor-Tests'!

!MMMemoryCellTest methodsFor: 'as yet unclassified' stamp: 'lt 5/8/2013 11:17:32.386'!
setUp
	startAddress := 16r1000.
	address := startAddress + 40.
	size := 100.
	memory := MMMemory withStartAddress: startAddress cellCount: size.
	
	cell := MMMemoryCell at: address in: memory! !

!MMMemoryCellTest methodsFor: 'as yet unclassified' stamp: 'WS 5/3/2013 14:15:58.392'!
testInitialization
	self assert: [ cell address == address ]! !

TestCase subclass: #MMMemoryTest
	instanceVariableNames: 'startAddress size memory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MemoryMentor-Tests'!

!MMMemoryTest methodsFor: 'as yet unclassified' stamp: 'WS 5/8/2013 14:01:05.856'!
setUp
	startAddress := 4096.
	size := 4.
	memory := MMMemory withStartAddress: startAddress cellCount: size! !

!MMMemoryTest methodsFor: 'as yet unclassified' stamp: 'WS 5/8/2013 14:06:38.408'!
testCellAccess
	self shouldnt: [ memory cellAtAddress: startAddress + 4 ] raise: Exception.
	self assert: [ (memory cellAtAddress: startAddress + 4) address == (startAddress + 4) ].
	
	self shouldnt: [ memory cellAtAddress: startAddress + 12 ] raise: Exception.
	self assert: [ (memory cellAtAddress: startAddress + 12) address == (startAddress + 12) ].
	
	self should: [ memory cellAtAddress: startAddress - 4 ] raise: Exception.
	
	self should: [ memory cellAtAddress: startAddress + (size * 4) ] raise: Exception
! !

!MMMemoryTest methodsFor: 'as yet unclassified' stamp: 'WS 5/3/2013 15:07:50.83'!
testCellIteration
	| cellIndex |
	cellIndex := 0.
	
	memory cellsDo: [ :cell |
		self assert: [ cell address == (4*cellIndex + startAddress) ].
		cellIndex := cellIndex + 1
	].
	
	self assert: [ cellIndex == size ]! !

!MMMemoryTest methodsFor: 'as yet unclassified' stamp: 'WS 5/8/2013 14:08:23.396'!
testData
	memory at: startAddress putByteArray: #(1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16).
	
	1 to: size * 4 do: [ :index |
		self assert: [ (memory byteAt: (index - 1 + startAddress)) == index ]
	]! !

!MMMemoryTest methodsFor: 'as yet unclassified' stamp: 'lt 5/8/2013 11:54:08.272'!
testInitialization
	self assert: [ memory startAddress == startAddress ].
	self assert: [ memory cellCount == size ].
	self assert: [ memory byteSize == (size * MMMemoryCell size)]! !

!MMMemoryTest methodsFor: 'as yet unclassified' stamp: 'WS 5/8/2013 14:05:30.808'!
testLongData
	self shouldnt: [ memory at: startAddress putByteArray: #(1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20) ] raise: Exception.
	self assert: [ memory cellCount == size ]! !
